<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Component validation</title>
</head>
<body>

<main>
    <candidate-component v-for="candidate in candidateList" :key="candidate.key"
               :name="candidate.name.first" :email="candidate.email"
               :image="candidate.picture.thumbnail" :location="candidate.location"></candidate-component>
</main>


<template id="candidate-template">
    <div>
        <img :src="image" align="right">
        <h2>{{ name }}</h2>
        <h3>{{ email }}</h3>
        <ul>
            <li v-for="(value, key, index) in location">{{ value }}</li>
        </ul>
        <hr>
    </div>
</template>

<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
<script src="https://unpkg.com/axios/dist/axios.min.js"></script>

<script>

    Vue.component('candidate-component', {
        // props: ['name', 'email', 'image'],
        props: {
            name: {
                type: String,
                required: true
            },
            email: {
                type: String,
                default: 'jose.florez@megaterios.co'
            },
            image: String,
            location: {
                type: Object,
                default() {
                    return {
                        city: 'Cúcuta'
                    }
                }
            }
        },
        template: '#candidate-template'
    });

    new Vue({
        el: 'main',
        mounted() {
            this.loadCandidates();
        },
        data: {
            candidateList: []
        },
        methods: {
            loadCandidates() {
                axios.get('https://randomuser.me/api/?results=50')
                    .then((response) => {
                        this.candidateList = response.data.results;
                    }).catch((error) => console.log(error))
            }
        }
    })
</script>

</body>
</html>